using Newtonsoft.Json;

namespace FitConnect.Models;

/// <summary>
/// Class for data exchange with the JavaScript client.
/// </summary>
public class EncryptedSubmission {
    public EncryptedSubmission(Guid destinationId, string serviceName, string serviceIdentifier,
        string data, string metadata, Dictionary<Guid, string> attachments) {
        DestinationId = destinationId;
        ServiceName = serviceName;
        ServiceIdentifier = serviceIdentifier;
        Data = data;
        Metadata = metadata;
        Attachments = attachments;
    }

    [JsonProperty("destinationId")]
    public Guid DestinationId { get; init; }

    [JsonProperty("serviceName")]
    public string ServiceName { get; init; }

    [JsonProperty("serviceIdentifier")]
    public string ServiceIdentifier { get; init; }

    [JsonProperty("data")]
    public string Data { get; init; }

    [JsonProperty("metadata")]
    public string Metadata { get; init; }

    [JsonProperty("attachments")]
    public Dictionary<Guid, string> Attachments { get; init; }
}
