using FitConnect.Services.Interfaces;
using FitConnect.Services.Models.v1.Case;
using Microsoft.Extensions.Logging;

namespace FitConnect.Services;

internal class CasesService : RestCallService, ICasesService {
    private readonly IOAuthService _oAuthService;

    public CasesService(string baseUrl, IOAuthService oAuthService, string version = "v1",
        ILogger? logger = null) : base(
        $"{baseUrl}/{version}", logger) {
        _oAuthService = oAuthService;
    }

    public async Task<string> FinishSubmissionAsync(Guid caseId, string token) {
        await _oAuthService.EnsureAuthenticatedAsync();
        var result = await RestCallForString($"/cases/{caseId}/events", HttpMethod.Post, token
            , "application/jose"
        );

        return result;
    }


    /// <summary>
    ///     <para>
    ///         @GetMapping("/cases/{caseId}/events")
    ///     </para>
    /// </summary>
    /// <param name="caseId">PathVariable</param>
    /// <param name="offset">RequestParam</param>
    /// <param name="limit">RequestParam</param>
    /// <returns></returns>
    public EventLogDto GetEventLog(string caseId, int offset, int limit) {
        throw new NotImplementedException();
    }

    // 
    /// <summary>
    ///     <para>@PostMapping(value = "/cases/{caseId}/events", consumes = "application/jose")</para>
    /// </summary>
    /// <param name="caseId">PathVariable</param>
    /// <param name="eventToken">RequestBody</param>
    /// <returns></returns>
    public bool ProcessCaseEvent(string caseId, string eventToken) {
        throw new NotImplementedException();
    }
}
